/*
 * $Log: options.cpp,v $
 * Revision 1.3  2003/02/15 11:14:53  ral
 * einiges umsortiert
 *
 * Revision 1.2  2003/02/15 10:02:17  ral
 * *** empty log message ***
 *
 * Revision 1.1  2003/02/14 23:01:51  ral
 * 2.0.0
 *
 * Revision 1.4  1999/07/05 04:37:34  ral
 * Einige Aenderungen, CVS umgemodelt
 *
 * Revision 1.3  1997/10/30 16:02:21  ral
 * all functions implemented
 *
 * Revision 1.2  1997/10/29 17:07:13  ral
 * *** empty log message ***
 *
 * Revision 1.1  1997/10/29 15:47:36  ral
 * Initial revision
 *
 */

#ifndef rcsid
static char rcsid[]="$Id: options.cpp,v 1.3 2003/02/15 11:14:53 ral Exp $";
#endif

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <ctype.h>

#include "options.h"
#include "profile.h"
#include "xqmixer/helpers/helpers.h"
#include <iostream>

using namespace std;

/*
 * if parafile == NULL
 * we will use the default ini-file ($HOME)/.XqMixer.ini)
 */
options::options (const char*parafile)
{
    error = 0;
    if (parafile) {
	file = parafile;
        pfile.FileName(file);
	return;
    }
    file = "";
    struct passwd * UserInfo;
    uid_t UserId;
    UserId = geteuid();
    UserInfo = getpwuid(UserId);
    if (UserInfo == NULL) {
	file = "could not retrieve user informations";
	error = -1;
        return;
    }
    file = UserInfo->pw_dir;
    file+= "/.xqmixer";
    pfile.FileName(file);
}

options::~options()
{
}

void options::setfile(const char*parafile)
{
    file = "";
    // if we want delete our profile-file
    if (!parafile)
	return;
    file =parafile;
    pfile.FileName(file);
}

int options::read_value(const char*section,const char*entry)
{
    if (file.size()==0)
	return -1;
    return pfile.getProfileInt(section,entry,0);
}

int options::write_value(const char*section,const char*entry,int nvalue)
{
    if (file.size()==0)
	return -1;
    return pfile.writeProfileInt(section,entry,nvalue);
}

void options::save_options()
{
    pfile.writeProfileInt("global","autosave",save_on_exit);
    pfile.writeProfileInt("global","Loadonlylayout",load_only_layout);
    pfile.writeProfileInt("global","StartupDisplay",all_display_on);
    pfile.writeProfileInt("global","IgnoreSingle",ignore_single_display);
    pfile.writeProfileInt("global","autoload",load_on_start);
    pfile.writeProfileInt("global","loadonlyvals",load_only_vals);
}

void options::load_options()
{
    save_on_exit = pfile.getProfileInt("global","autosave",0);
    load_on_start = pfile.getProfileInt("global","autoload",0);
    load_only_layout = pfile.getProfileInt("global","Loadonlylayout",0);
    all_display_on = pfile.getProfileInt("global","StartupDisplay",0);
    ignore_single_display = pfile.getProfileInt("global","IgnoreSingle",0);
    load_only_vals = pfile.getProfileInt("global","loadonlyvals",0);
}

